diff a/src/hotspot/share/interpreter/zero/bytecodeInterpreter.cpp b/src/hotspot/share/interpreter/zero/bytecodeInterpreter.cpp
--- a/src/hotspot/share/interpreter/zero/bytecodeInterpreter.cpp
+++ b/src/hotspot/share/interpreter/zero/bytecodeInterpreter.cpp
@@ -639,13 +639,10 @@
               mon->lock()->set_displaced_header(markWord::from_pointer(nullptr));
             } else {
               success = false;
             }
           }
-          if (success) {
-            THREAD->inc_held_monitor_count();
-          }
         }
         if (!success) {
             CALL_VM(InterpreterRuntime::monitorenter(THREAD, mon), handle_exception);
         }
 
@@ -743,13 +740,10 @@
             entry->lock()->set_displaced_header(markWord::from_pointer(nullptr));
           } else {
             success = false;
           }
         }
-        if (success) {
-          THREAD->inc_held_monitor_count();
-        }
       }
       if (!success) {
         CALL_VM(InterpreterRuntime::monitorenter(THREAD, entry), handle_exception);
       }
 
@@ -1678,13 +1672,10 @@
                 entry->lock()->set_displaced_header(markWord::from_pointer(nullptr));
               } else {
                 success = false;
               }
             }
-            if (success) {
-              THREAD->inc_held_monitor_count();
-            }
           }
           if (!success) {
             CALL_VM(InterpreterRuntime::monitorenter(THREAD, entry), handle_exception);
           }
 
@@ -1718,13 +1709,10 @@
                   // restore object for the slow case
                   most_recent->set_obj(lockee);
                   success = false;
                 }
               }
-              if (success) {
-                THREAD->dec_held_monitor_count();
-              }
             }
             if (!success) {
               InterpreterRuntime::monitorexit(most_recent);
             }
             UPDATE_PC_AND_TOS_AND_CONTINUE(1, -1);
@@ -3161,13 +3149,10 @@
                 // restore object for the slow case
                 end->set_obj(lockee);
                 success = false;
               }
             }
-            if (success) {
-              THREAD->dec_held_monitor_count();
-            }
           }
           if (!success) {
             InterpreterRuntime::monitorexit(end);
           }
 
@@ -3240,13 +3225,10 @@
                   if (!suppress_error) illegal_state_oop = Handle(THREAD, THREAD->pending_exception());
                   THREAD->clear_pending_exception();
                 }
               }
             }
-            if (dec_monitor_count) {
-              THREAD->dec_held_monitor_count();
-            }
           }
         }
       }
     }
     // Clear the do_not_unlock flag now.
